<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.17.2.12.2.5 $
 * $Author: tora60 $
 * $Date: 2009/05/27 10:42:02 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * definiert, dass diese Datei bereits includet wurde
 * !! nicht veraendern !!
 */
if (isset($GLOBALS['footer_is_shown'])) {
    return;
}
$GLOBALS['footer_is_shown'] = true;
$GLOBALS['footer'] = 1;

/**
 * untere Centerbloecke anzeigen, direkt unter der Ausgabe des Moduls,
 * Bei vkpMx-Themes ist diese Ausgabe im Theme definiert
 */
if (defined('MX_HOME_FILE') && empty($GLOBALS['VKPTheme'])) {
    blocks('down');
}

/**
 * Funktion 'themefooter' aus Theme aufrufen.
 * Darin werden auch die rechten Bloecke angezeigt
 */
themefooter();

/**
 * private Nachrichten der User abfragen
 */
if (MX_IS_USER) {
    $uinf = mxGetUserData();
    $checkpmtime = (intval($uinf['user_pm_poptime'])) * 1000; // Milisekunden !!!
    if ($checkpmtime > 0 && $GLOBALS['pm_poptime'] && mxModuleAllowed('Private_Messages')) {

        ?>
<div style="position: absolute; left: -10000px;">
<iframe name="checkpm" src="modules.php?name=Private_Messages&amp;file=buddy&amp;op=check&amp;ref_intervall=<?php echo $checkpmtime ?>" marginwidth="0" marginheight="0" width="0" height="0" scrolling="no" frameborder="0" id="checkpm"></iframe>
</div>
<?php
    }
}

/**
 * zusaetzliche Datei fuer benutzerdefinierte Zusaetze am Ende der HTML-Ausgabe
 */
include_once(PMX_SYSTEM_DIR . DS . 'my_footer.php');

/**
 * den Ausgabepuffer nachbehandeln
 * Der Ausgabepuffer wurde in mainfile.php explizit gestartet!
 * falls doch leer, ist z.B. nix mit mod_rewrite
 */
if (ob_get_length()) {
    /* die HTML-Ausgabe beenden */
    ?>

</body>
</html>
<?php

    $mxoutput = trim(ob_get_clean());
    // Das Array mit den versch. Doc-Type Deklarationen auslesen
    $doctype_arr = mxDoctypeArray($GLOBALS['DOCTYPE']);

    /**
     * HTML-Validation
     */
    // tidy, falls vorhanden und eingeschaltet
    if ($GLOBALS['TidyOutput'] && !extension_loaded('tidy') && function_exists('dl')) {
        @dl('tidy');
    }
    if ($GLOBALS['TidyOutput'] && class_exists('tidy', false) && !function_exists('tidy_set_encoding')) {
        /* zusaetzliche headertags vorher noch an die korrekte Stelle setzen */
        $mxoutput = pmxHeader::move($mxoutput);
        // Specify configuration: http://tidy.sourceforge.net/docs/quickref.html
        $tidyconfig = array('output-html' => $doctype_arr['html'],
            'output-xhtml' => $doctype_arr['xhtml'],
            'add-xml-decl' => $doctype_arr['xhtml'],
            'doctype' => $doctype_arr['tidy_doctype'],
            'wrap' => 0,
            'indent' => false,
            // 'indent-spaces' => 1,
            // 'clean'   => true,
            // 'alt-text' => 'img',
            );
        // mxDebugFuncVars($tidyconfig);
        // Tidy
        $tidy = new tidy;
        $tidy->parseString($mxoutput, $tidyconfig, 'latin1');
        $tidy->cleanRepair();
        $mxoutput = $tidy;
        // die tidy-Funktion fuegt vor </textara> einen Zeilenumbruch ein, diesen hier entfernen
        $mxoutput = preg_replace('#\s*</textarea>#', '</textarea>', $mxoutput);
        unset($tidy);
    } else {
        /* zusaetzliche headertags an die korrekte Stelle setzen */
        $mxoutput = pmxHeader::move($mxoutput);
        if ($doctype_arr['xhtml']) {
            // versuchen, die xhtml-Endung anzufuegen
            $mxoutput = preg_replace('#<((?:img|input|hr|br|link|meta|base)(?:[^>]*[^/])?)>#i', '<$1 />', $mxoutput);
            // bei <img> muss ein ALT Attribut spezifiert sein, hier versuchen die anzufuegen, falls es fehlt
            $mxoutput = preg_replace('#(<img[^>]*)/>#ie', 'stripslashes((preg_match("!\salt\s*=!i", \'\1\'))?\'\0\':\'\1 alt=\"\" />\')', $mxoutput);
        } else {
            // die xhtml-Endung < /> entfernen, da Fehler in HTML 4.01
            $mxoutput = preg_replace('#(<[[:alnum:]]+[^>]*)/>#', '$1>', $mxoutput);
            // bei <img> muss ein ALT Attribut spezifiert sein, hier versuchen die anzufuegen, falls es fehlt
            $mxoutput = preg_replace('#(<img[^>]*)>#ie', 'stripslashes((preg_match("!\salt\s*=!i", \'\1\'))?\'\0\':\'\1 alt=\"\">\')', $mxoutput);
        }
        // der spaw-Editor setzt manchmal komische type-Attribute dazu
        $mxoutput = str_replace(' type="_moz"', '', $mxoutput);
        // Link auf ungueltige Verweise entfernen, kommt evtl. von Spaw, etc.
        $mxoutput = preg_replace('!\s+href="#?"!i', '', $mxoutput);
    }
    /* ENDE HTML-Validation */

    /* interne Anker (#) fuer base-href tauglich machen */
    $mxoutput = preg_replace('!(\s+href=(["\']))(#[^"\']+)(\2)!i', '\1' . str_replace('&', '&amp;', basename($_SERVER['REQUEST_URI'])) . '\3\2', $mxoutput);

    /* mod_rewrite, Ersetzen der Links in ein suchmaschinenfreundliches Format. */
    if ($mxoutput && ((!empty($GLOBALS['mxUseModrewrite']['anony']) && !MX_IS_USER && !MX_IS_ADMIN) ||
                (!empty($GLOBALS['mxUseModrewrite']['users']) && MX_IS_USER && !MX_IS_ADMIN) ||
                (!empty($GLOBALS['mxUseModrewrite']['admin']) && MX_IS_ADMIN)) && is_file('.htaccess')) {
        if (!function_exists('mxPrepareModRewrite')) {
            include_once(PMX_SYSTEM_DIR . DS . 'mx_modrewrite.php');
        }
        $mxoutput = mxPrepareModRewrite($mxoutput);
    }
    /* ENDE mod_rewrite */

    /* zusaetzliche optionale Datei um den Ausgabepuffer zu manipulieren */
    if ($file = realpath(PMX_SYSTEM_DIR . DS . 'prepareoutput.php')) {
        include($file);
    }

    /**
     * den html-Output (Ausgabepuffer) ausgeben
     */
    echo $mxoutput;

    /**
     * Speicher aufraeumen
     */
    unset($mxoutput, $matches, $allstyles);
} else {
    /* falls kein Ausgabepuffer vorhanden, die zusaetzlichen Header-Tags zumindest noch ans Ende schreiben... */
    echo pmxHeader::get();
    /* das Ende, der HTML-Ausgabe */
    ?>

</body>
</html>
<?php }

?>